Zavrsni/urls.py
from django.contrib import admin
from django.urls import path
from django.conf.urls import include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('users/', include('users.urls')),
    path('comm/', include('common.urls')),
    path('unis/', include('unis.urls')),
    path('relations/', include('relations.urls')),
    path('', include('posts.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root= settings.MEDIA_ROOT)

unis/urls.py
from django.urls import path
from unis.views import CroUniListVieW, ExUniListVieW, ExUniDetailView, CroUniDetailView, CroUniListVieWSecond

urlpatterns = [
    path('exunis/', ExUniListVieW.as_view(), name="ex-list"),
    path('crounis/', CroUniListVieW.as_view(template_name='unis/crounis1.html'), name="cro-list"),
    path('crounis2/<int:pk>', CroUniListVieWSecond.as_view(template_name='unis/crounis.html'), name="cro-list2"),
    path('exunis/<int:pk>/', ExUniDetailView.as_view(), name="exuni-detail"),
    path('crounis/<int:pk>/', CroUniDetailView.as_view(), name="crouni-detail"),
]

posts/models.py
from django.db import models
from users.models import CustomUser
from django.urls import reverse
from relations.models import Relation
from unis.models import ExUni
from common.models import City, FinanceType
from PIL import Image
from django.core.validators import MaxValueValidator, MinValueValidator


class Post(models.Model):
    author = models.OneToOneField(CustomUser, on_delete=models.SET_NULL, null=True, blank=True)
    relation = models.ForeignKey(Relation, on_delete=models.SET_NULL, null=True, blank=True)

    title = models.CharField(max_length=100, default="")
    ex_year = models.IntegerField(default=2019, blank=False, validators=[
            MinValueValidator(1975),
            MaxValueValidator(2019)
        ])
    generally = models.TextField(blank=True, null=True)
    last_modified = models.DateTimeField('date_published', auto_now=True)

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.pk})

class AboutCity(models.Model):
    city = models.ForeignKey(City, on_delete=models.CASCADE, null=True)
    post = models.OneToOneField(Post, on_delete=models.CASCADE, null=True)

    places_to_see = models.TextField(blank=True, null=True)
    city_traffic = models.TextField(blank=True, null=True)
    how_to_arrive = models.TextField(blank=True, null=True)
    where_to_go = models.TextField(blank=True, null=True)
    food = models.TextField(blank=True, null=True)

    def __str__(self):
        return self.city.name

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.post.pk})

class AboutUni(models.Model):
    ex_uni = models.ForeignKey(ExUni, on_delete=models.CASCADE, null=True)
    post = models.OneToOneField(Post, on_delete=models.CASCADE, null=True)

    generally = models.TextField(blank=True, null=True)
    prof = models.TextField(blank=True, null=True)
    subjects = models.TextField(blank=True, null=True)

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.post.pk})

    def __str__(self):
        return self.ex_uni.name

class Media(models.Model):
    post = models.ForeignKey(Post, null=True, blank=True, on_delete=models.CASCADE)

    myimage = models.FileField(upload_to='images/', null=True, verbose_name="")

    def __str__(self):
        return str(self.myimage)

    #resize
    def save(self, *args, **kwargs):
        super().save(*args, **kwargs)
        img = Image.open(self.myimage.path)

        if img.height > 700 or img.width > 700:
            output_size = (700, 700)
            img.thumbnail(output_size)
            img.save(self.myimage.path)



class Finance(models.Model):
    finance_type = models.ForeignKey(FinanceType, on_delete=models.CASCADE)
    post = models.ForeignKey(Post, on_delete=models.CASCADE)
    amount = models.PositiveIntegerField(default=0)
    ordering = ['amount']

    def __str__(self):
        return self.finance_type.__str__() + "-" + self.amount.__str__()

    def get_absolute_url(self):
        return reverse('finance-list', kwargs={'pk': self.post.pk})

    class Meta:
        unique_together = (("finance_type", 'post'),)

relations/models.py
from django.db import models
from unis.models import CroUni, ExUni

class ISCEDArea(models.Model):
    isced_id = models.CharField(max_length=100)
    isced_name = models.CharField(max_length=100)

    def __str__(self):
        return self.isced_id

class Programme(models.Model):
    name = models.CharField(max_length=300)
    short_name = models.CharField(max_length=100, default="sms")

    def __str__(self):
        return self.short_name


class Relation(models.Model):
    cro_uni = models.ForeignKey(CroUni, on_delete=models.DO_NOTHING)
    ex_uni = models.ForeignKey(ExUni, on_delete=models.DO_NOTHING)
    ISCED_Area = models.ForeignKey(ISCEDArea, on_delete=models.DO_NOTHING)
    program = models.ForeignKey(Programme, on_delete=models.DO_NOTHING)

    bachelor = models.BooleanField(default=False)
    master = models.BooleanField(default=False)
    doctorate = models.BooleanField(default=False)
    duration_in_months = models.IntegerField()

    def __str__(self):
        return self.cro_uni.name+str("-")+self.ex_uni.name + str("-") + "(" + self.ISCED_Area.isced_id+")"+ self.program.short_name

    class Meta:
        ordering = ('program', 'cro_uni', 'ex_uni', 'duration_in_months')

unis/models.py
from django.db import models
from common.models import City
from django.urls import reverse


class ExUni(models.Model):
    ex_uni = models.ForeignKey('self', on_delete=models.SET_NULL, null=True, blank=True)
    city = models.ForeignKey(City, on_delete=models.DO_NOTHING, null=True)

    name = models.CharField(max_length=100)

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('exuni-detail', kwargs={'pk': self.pk})

class CroUni(models.Model):
    cro_uni = models.ForeignKey('self', on_delete=models.SET_NULL, null=True, blank=True)

    name = models.CharField(max_length=100)

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return reverse('crouni-detail', kwargs={'pk': self.pk})

unis/views.py
from django.views.generic import (ListView,	DetailView)
from .models import CroUni, ExUni
from django.db.models.functions import Lower


class ExUniListVieW(ListView):
	model = ExUni
	template_name = 'unis/exunis.html'
	context_object_name = 'exunis'
	paginate_by = 7
	ordering = [Lower('name')]


class ExUniDetailView(DetailView):
	model = ExUni


class CroUniDetailView(DetailView):
	model = CroUni


class CroUniListVieW(ListView):
	model = CroUni
	ordering = [Lower('name')]
	context_object_name = 'crounis'


class CroUniListVieWSecond(ListView):
	model = CroUni
	paginate_by = 7
	ordering = [Lower('name')]

	def get_queryset(self):
		context = CroUni.objects.filter(cro_uni_id = self.kwargs['pk'])
		return context

unis/templates/unis/crouni_detail.html
{% extends "posts/base.html"%}
{% block page_content %}
    <font color=black>

    {% if object.relation_set.count <= 0 %}

      <div id="banner" class="container">
        <section>
            <p>There is no reviews about that university</p>
        </section>
    </div>
        {% endif %}


    {% for a in object.relation_set.all %}
    {% for about in a.post_set.all %}


    <div id="page" class="container">
    <div class="row">

        <div id="sidebar" class="4u">
        <section>
            <header class="major">
                <h2>Details:</h2>
            </header>
            <div class="row half">
                <section class="6u">
                    <ul class="default">
                        {% if about.author %}
                        <li><b>Author: <br>{{ about.author }}, {{ about.relation.cro_uni }}</b></li>
                        {% else %}
                        <li><font color="red">Erased profile</font></li>
                        {% endif %}
                        <li><b>{{ about.aboutuni.ex_uni }}, {{ about.ex_year }}</b></li>
                        <li><b>Programm: {{ about.relation.program.short_name }}</b><br><b>ISCED Area: {{ about.relation.ISCED_Area }}</b></li>
                    </ul>
                </section>
            </div>
        </section>
    </div>


    <div id="content" class="8u skel-cell-important">
        <section>
            <header class="major">
                <h2>{{ about.title }} - {{ about.relation.cro_uni }}</h2>
                <span class="byline">{{ about.last_modified|date:"F d, Y" }}</span>
                {% if about.author == user %}
                    <div>
                        <a class = "btn btn-secondary btn-sm mt-1 mb-1" href={% url 'post-update' about.id %}>Update</a>
                    </div>
                {% endif %}
           </header>

                {% if about.generally %}
                <b class="byline">ABOUT EXCHANGE:</b>
                <p>{{ about.generally }}</p>
                {% endif %}
        </section>
        <a href="{% url 'post-detail' about.id %}" class="button">Read More</a>

    </div>

    </div>
    </div>

    <p></p><p></p>

    {% endfor %}
    {% endfor %}


    {% if is_paginated %}
     <div id="banner" class="big">
        <section>
      {% if page_obj.has_previous %}
        <a href="?page=1"><strong>First</strong></a>
        <a href="?page={{ page_obj.previous_page_number }}"><strong>Previous</strong></a>
      {% endif %}

      {% for num in page_obj.paginator.page_range %}
        {% if page_obj.number == num %}
          <a href="?page={{ num }}"><strong>{{ num }}</strong></a>
        {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
          <a href="?page={{ num }}"><strong>{{ num }}</strong></a>
        {% endif %}
      {% endfor %}

      {% if page_obj.has_next %}
        <a href="?page={{ page_obj.next_page_number }}"><strong>Next</strong></a>
        <a href="?page={{ page_obj.paginator.num_pages }}"><strong>Last</strong></a>
      {% endif %}
    </section>
{% endif %}
</div>
    </font>
{% endblock %}

unis/templates/unis/crounis.html
{% extends 'posts/base.html' %}
{% block main_banner %}



    {% if object_list.count <= 0 %}

      <div id="banner" class="container">
        <section>
            <p>There is no reviews about that university</p>
        </section>
    </div>

        {% else %}

         <div id="banner" class="container">
        <section>
            <p>Choose univesity you whant to explore</p>
        </section>
    </div>

        {% endif %}
{% endblock main_banner %}

{% block out_box_sections %}

    <div id="extra">
    <div class="container">
        <div class="row no-collapse-1">
            <section>
                    {% for uni in object_list %}
                            <ul>
                            <a href="{% url 'crouni-detail' uni.id %}" class="button">{{ uni }}</a>
                            </ul>
                        {% endfor %}
            </section>
       </div>
    </div>
</div>


{% if is_paginated %}
     <div id="banner" class="big">
        <section>
      {% if page_obj.has_previous %}
        <a href="?page=1"><strong>First</strong></a>
        <a href="?page={{ page_obj.previous_page_number }}"><strong>Previous</strong></a>
      {% endif %}

      {% for num in page_obj.paginator.page_range %}
        {% if page_obj.number == num %}
          <a href="?page={{ num }}"><strong>{{ num }}</strong></a>
        {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
          <a href="?page={{ num }}"><strong>{{ num }}</strong></a>
        {% endif %}
      {% endfor %}

      {% if page_obj.has_next %}
        <a href="?page={{ page_obj.next_page_number }}"><strong>Next</strong></a>
        <a href="?page={{ page_obj.paginator.num_pages }}"><strong>Last</strong></a>
      {% endif %}
    </section>
    </div>
{% endif %}
{% endblock out_box_sections %}

unis/templates/unis/crounis1.html
{% extends 'posts/base.html' %}
{% block main_banner %}

    <div id="banner" class="container">
        <section>
            <p>Choose univesity you whant to explore</p>
        </section>
    </div>
{% endblock main_banner %}

{% block out_box_sections %}
    <div class="container">
        <div class="row">

            <!-- Content -->
            <div class="6u">
                <section>
                        {% for uni in crounis %}
                            <ul>
                            {% if uni.cro_uni %}
                            {% else %}
                            <a href="{% url 'cro-list2' uni.id %}" class="button">{{ uni }}</a>
                            {% endif %}
                            </ul>
                        {% endfor %}
                </section>
            </div>
        </div>
    </div>
{% endblock out_box_sections %}

unis/templates/unis/exuni_detail.html
{% extends "posts/base.html"%}
{% block page_content %}
    <font color=black>

    {% for about in object.aboutuni_set.all %}
    <div id="page" class="container">
    <div class="row">

        <div id="sidebar" class="4u">
        <section>
            <header class="major">
                <h2>Details:</h2>
            </header>
            <div class="row half">
                <section class="6u">
                    <ul class="default">
                        {% if about.post.author %}
                        <li><b>Author: <br>{{ about.post.author }}, {{ about.post.relation.cro_uni }}</b></li>
                        {% else %}
                        <li><font color="red">Erased profile</font></li>
                        {% endif %}
                        <li><b>{{ about.post.aboutuni.ex_uni }}, {{ about.post.ex_year }}</b></li>
                        <li><b>Programm: {{ about.post.relation.program.short_name }}</b><br><b>ISCED Area: {{ about.post.relation.ISCED_Area }}</b></li>
                    </ul>
                </section>
            </div>
        </section>
    </div>


    <div id="content" class="8u skel-cell-important">
        <section>
            <header class="major">
                <h2>{{ about.post.title }} - {{ about.ex_uni.name }}</h2>
                <span class="byline">{{ about.post.last_modified|date:"F d, Y" }}</span>
                {% if about.post.author == user %}
                    <div>
                        <a class = "btn btn-secondary btn-sm mt-1 mb-1" href={% url 'aboutuni-update' about.id %}>Update</a>
                    </div>
                {% endif %}
           </header>

                {% if about.generally %}
                <b class="byline">ABOUT UNIVERSITY:</b>
                <p>{{ about.generally }}</p>
                 {% elif about.subjects %}
               <b class="byline">SUBJECTS:</b>
                <p>{{ about.subjects }}</p>
                {% elif about.prof %}
                <b class="byline">PROFESSORS:</b>
                <p>{{ about.prof }}</p>
                {% endif %}
        </section>
        <a href="{% url 'post-detail' about.post.id %}" class="button">Read More</a>

    </div>

    </div>
    </div>

    <p></p><p></p>

    {% endfor %}

    {% if is_paginated %}
     <div id="banner" class="big">
        <section>
      {% if page_obj.has_previous %}
        <a href="?page=1"><strong>First</strong></a>
        <a href="?page={{ page_obj.previous_page_number }}"><strong>Previous</strong></a>
      {% endif %}

      {% for num in page_obj.paginator.page_range %}
        {% if page_obj.number == num %}
          <a href="?page={{ num }}"><strong>{{ num }}</strong></a>
        {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
          <a href="?page={{ num }}"><strong>{{ num }}</strong></a>
        {% endif %}
      {% endfor %}

      {% if page_obj.has_next %}
        <a href="?page={{ page_obj.next_page_number }}"><strong>Next</strong></a>
        <a href="?page={{ page_obj.paginator.num_pages }}"><strong>Last</strong></a>
      {% endif %}
    </section>
{% endif %}
</div>
    </font>
{% endblock %}

unis/templates/unis/exunis.html
{% extends 'posts/base.html' %}
{% block main_banner %}

    <div id="banner" class="container">
        <section>
            <p>Choose univesity you whant to explore</p>
        </section>
    </div>
{% endblock main_banner %}

{% block out_box_sections %}
    <div class="container">
        <div class="row">

            <!-- Content -->
            <div class="6u">
                <section>
                        {% for uni in exunis %}
                            <ul>
                            {% if uni.aboutuni_set.count > 0 %}
                            <a href="{% url 'exuni-detail' uni.id %}" class="button">{{ uni }}</a>
                            {% endif %}
                            </ul>
                        {% endfor %}
                </section>
            </div>
        </div>
    </div>

<!--
{% if is_paginated %}
     <div id="banner" class="big">
        <section>
      {% if page_obj.has_previous %}
        <a href="?page=1"><strong>First</strong></a>
        <a href="?page={{ page_obj.previous_page_number }}"><strong>Previous</strong></a>
      {% endif %}

      {% for num in page_obj.paginator.page_range %}
        {% if page_obj.number == num %}
          <a href="?page={{ num }}"><strong>{{ num }}</strong></a>
        {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
          <a href="?page={{ num }}"><strong>{{ num }}</strong></a>
        {% endif %}
      {% endfor %}

      {% if page_obj.has_next %}
        <a href="?page={{ page_obj.next_page_number }}"><strong>Next</strong></a>
        <a href="?page={{ page_obj.paginator.num_pages }}"><strong>Last</strong></a>
      {% endif %}
    </section>
    </div>
{% endif %}
{% endblock out_box_sections %}

-->